window.Gleam.initSearch([{"doc":"lustre_hash_state","title":"lustre_hash_state","content":"# lustre_hash_state\n\n[![Package Version](https://img.shields.io/hexpm/v/lustre_hash_state)](https://hex.pm/packages/lustre_hash_state)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/lustre_hash_state/)\n\n```sh\ngleam add lustre_hash_state\n```\n\n```gleam\nimport lustre_hash_state\n\npub opaque type Msg {\n  // ...\n  HashChange(key: String, value: String)\n}\n\npub fn main() {\n  let app = lustre.application(init, update, view)\n  let assert Ok(_) = lustre.start(app, &quot;#app&quot;, Nil)\n}\n\nfn init(_flags) -&gt; #(Model, effect.Effect(Msg)) {\n  #(Model(dict.new()), lustre_hash_state.init(HashChange))\n}\n\nfn update(model: Model, msg: Msg) -&gt; #(Model, effect.Effect(msg)) {\n  case msg {\n    // hash change events can update the model\n    HashChange(key, value) -&gt; {\n      #(Model(dict.update(dct, key, fn(_x) { value })), effect.none())\n    }\n    UserUpdatedMessage(key, value) -&gt; {\n      #(\n        Model(dict.update(dct, key, fn(_x) { value })),\n        // and user events can update the hash\n        lustre_hash_state.update(key, value),\n      )\n    }\n    // ...\n  }\n}\n\nfn view(model: Model) -&gt; Element(Msg) {\n  let Model(dct) = model\n\n  ui.group([], [\n    ui.field(\n      [],\n      [element.text(&quot;Write a message:&quot;)],\n      ui.input([\n        attribute.value(result.unwrap(dict.get(dct, &quot;message&quot;), &quot;&quot;)),\n        event.on_input(fn(value) { UserUpdatedMessage(&quot;message&quot;, value) }),\n      ]),\n      [],\n    ),\n  ])\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/lustre_hash_state&gt;.\n\n## Development\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\n```\n","url":"index.html"},{"doc":"lustre_hash_state","title":"get_hash","content":"pub fn get_hash() -&gt; String\n Returns the current window.location.hash value, including the octothorpe.\n It&#39;s unlikely you&#39;d call this directly, but public for convenience.\nSynonyms:\nlustre_hash_state.get_hash\nlustre_hash_state get_hash","url":"lustre_hash_state.html#get_hash"},{"doc":"lustre_hash_state","title":"init","content":"pub fn init(msg: fn(String, String) -&gt; a) -&gt; Effect(a)\n The effect to be returned in your init method. Sets up hashchange event\n listener and sends messages to update.\nSynonyms:\nlustre_hash_state.init\nlustre_hash_state init","url":"lustre_hash_state.html#init"},{"doc":"lustre_hash_state","title":"noop","content":"pub fn noop() -&gt; Effect(a)\n A convenience method identical to effect.none()\nSynonyms:\nlustre_hash_state.noop\nlustre_hash_state noop","url":"lustre_hash_state.html#noop"},{"doc":"lustre_hash_state","title":"parse_hash","content":"pub fn parse_hash(query: String) -&gt; Dict(String, String)\n Parses a query string into a dict\nSynonyms:\nlustre_hash_state.parse_hash\nlustre_hash_state parse_hash","url":"lustre_hash_state.html#parse_hash"},{"doc":"lustre_hash_state","title":"stringify_hash","content":"pub fn stringify_hash(dct: Dict(String, String)) -&gt; String\n Converts a dict to a query string\nSynonyms:\nlustre_hash_state.stringify_hash\nlustre_hash_state stringify_hash","url":"lustre_hash_state.html#stringify_hash"},{"doc":"lustre_hash_state","title":"update","content":"pub fn update(key: String, value: String) -&gt; Effect(a)\n Updates the hash value.\nSynonyms:\nlustre_hash_state.update\nlustre_hash_state update","url":"lustre_hash_state.html#update"},{"doc":"lustre_hash_state","title":"lustre_hash_state","content":"","url":"lustre_hash_state.html"}]);